////////////////////////////////////////////////////////////////////////////////
//
// UFRGS - INF01151 - Marcelo Johann - 2009/1
//
// Producer and Consumer in C with POSIX Unnamed Semaphores
//
// I AM NOT SURE THIS PROGRAM IS WORKING FLAWLESSLY, AS UNNAMED SEMAPHORES
// ARE NOT YET IMPLEMENTED IN THE MAC OSX I AM USING TO TEST

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>

// definitions

#define TRUE 1
#define FALSE 0
#define BUFFER_SIZE 20
#define DELAY_BUFFER 400
#define DELAY_MONITOR 500

// prototypes

void delay (int ticks);

// structure for thread identification and timing

typedef struct
  {
  char name;
  int ticks;
  } ThreadID;
  
// structure for the item that goes in the buffer

typedef struct
  {
  char owner;
  int number;
  } Item;
  
// Global buffer and its opperations  
  
Item Buffer[BUFFER_SIZE];
int nextFree=0;
int lastItem=0;
void bufferInit(void);
void bufferPrint(void);
void bufferInsert(char name, int number);
Item bufferRemove(void);

// Global synchronizing semaphores
// Pay attention to initial values inside the main function

sem_t *mutex;
sem_t *empty_places;
sem_t *available_items;

// This variable is used by all threads to know when  the user wants to stop

int running = TRUE;

// Consumer and Producer´s code

void * consumer( void *par)
 {
 ThreadID *me = (ThreadID*) par;
 Item it;
 while (running==TRUE)
   {
   delay(me->ticks);
   it = bufferRemove();
   fprintf(stderr,"Consumer %c got %c%d\n",me->name,it.owner,it.number);
   }
 return 0;
 }
 
void * producer( void *par)
  {
  int i=0;
  ThreadID *me = (ThreadID*) par;
  for (i=0; running==TRUE ;++i)
    {
    delay(me->ticks);
    fprintf(stderr,"Producer %c to write %d\n",me->name,i);
    bufferInsert(me->name,i);
    }
  return 0;
  }
 
void bufferInit(void)
  {
  int i=0;
  Item nothing = {' ',0};
  for (i=0; i<BUFFER_SIZE; ++i)
    Buffer[i]= nothing;
  }

// Buffer´s code
  
void bufferPrint(void)
  {
  int i=0;
  fprintf(stderr,"Buffer: ");
  for (i=0; i<BUFFER_SIZE; ++i)
    fprintf(stderr,"%c%d ",Buffer[i].owner,Buffer[i].number);
  fprintf(stderr,"\n");
  }
 
void bufferInsert(char name, int number)
  {
  Item fresh;
  fresh.owner = name;
  fresh.number = number;
  sem_wait(empty_places);
  sem_wait(mutex);
  Buffer[nextFree]=fresh;
  delay(DELAY_BUFFER);
  nextFree = (nextFree+1)%BUFFER_SIZE;
  delay(DELAY_BUFFER);
  sem_post(mutex);
  sem_post(available_items);
  }
 
Item bufferRemove(void)
  {
  Item out;
  Item nothing = {' ',0};
  sem_wait(available_items);
  sem_wait(mutex);
  out = Buffer[lastItem];
  Buffer[lastItem] = nothing;
  delay(DELAY_BUFFER);
  lastItem = (lastItem+1)%BUFFER_SIZE;
  delay(DELAY_BUFFER);
  sem_post(mutex);
  sem_post(empty_places);
  return out;
  }
  
void *bufferMonitor(void *nothing)
  {
  while (running==TRUE)
    {
    bufferPrint();
    delay(DELAY_MONITOR);
    }
  return 0;
  }

// Main application

int main (int argc, char ** argv)
  {
  char command = ' ';
  pthread_t mon;
  pthread_t prod1,prod2;
  pthread_t cons1,cons2;
  pthread_attr_t at;

  pthread_attr_init(&at);
  pthread_attr_setscope(&at,PTHREAD_SCOPE_SYSTEM);

  ThreadID idprod1 = {'A',3000};
  ThreadID idprod2 = {'B',4000};
  ThreadID idcons1 = {'X',5000};
  ThreadID idcons2 = {'Y',2000};
    
  // create and initialize semaphores.
  // This is the unnamed version of POSIX semaphores
  // They are automatically destroyed when the program finishes
  
  sem_init(mutex,0,1);
  sem_init(empty_places,0,BUFFER_SIZE);
  sem_init(available_items,0,0);

  bufferInit();
  pthread_create(&mon, &at ,bufferMonitor,  0);
  pthread_create(&prod1, &at ,producer,  (void*) &idprod1);
  pthread_create(&prod2, &at ,producer,  (void*) &idprod2);
  pthread_create(&cons1, &at ,consumer,  (void*) &idcons1);
  pthread_create(&cons2, &at ,consumer,  (void*) &idcons2);
  
  // wait for the user to command EXIT
  
  fprintf(stderr,"UNNAMED: All created\n");
  while (command != 'e' && command != 'E')
    command = getchar();
  running = FALSE;
  
  // wait for  all threads to finish
  
  pthread_join(prod1, NULL);
  pthread_join(prod2, NULL);
  pthread_join(cons1, NULL);
  pthread_join(cons2, NULL);
  pthread_join(mon, NULL);
  
  // destroy the semaphores: this is not actually needed
  
  sem_destroy(mutex);
  sem_destroy(empty_places);
  sem_destroy(available_items);
  exit(0);
  }
 
void delay (int ticks)
  {
  int j,k;
    for (j=0;j<ticks;++j)
      {
      for (k=0;k<10000;++k)
        {
        j = j + 100;
        j = j - 100;
        }
      }
  }
